<?php

error_reporting(0); ## LIVE

#ini_set('display_errors', 1); ## TESTING
#error_reporting(E_ALL);  ## TESTING


header("Content-Type: text/html; charset=utf-8");
mb_internal_encoding('UTF-8');

$sessionName = "JTS3ServerModWebUI";
session_name($sessionName);
@session_start();

if (!isset($_SESSION['ipaddress']) || $_SESSION['ipaddress'] != $_SERVER["REMOTE_ADDR"])
	die("ERR 1");

function getBotCheckLogInfo($botID, $translation)
{
	$message = $translation->getTranslation("webui_checkloginfo");
	$message = str_replace('{botloglink}', "<a href=\"index.php?page=botlogview&amp;botID=".$botID."&amp;logtype=warning\">", $message);
	$message = str_replace('{botloglinkend}', "</a>", $message);
	return $message;
}

function saveValue($botid, $class_db, $configkey, $configvalue)
{
	if (is_numeric($botid))
	{
		$resCheckValue = $class_db->db_query("SELECT configvalue FROM jts3servermod_instanceconfig WHERE instance_id = ".$botid." AND configkey = '".$class_db->getRealEscapeString($configkey)."'");

		if (is_array($configvalue))
		{
			$configvalue = implode(",", $configvalue);
		}

		$configvalue = str_replace("\r", "", $configvalue);

		if (mysqli_num_rows($resCheckValue) == 1)
		{
			$checkValue = mysqli_fetch_array($resCheckValue);
			if ($checkValue[0] != $configvalue)
			{
				$class_db->db_query("UPDATE jts3servermod_instanceconfig SET configvalue = '".$class_db->getRealEscapeString($configvalue)."' WHERE instance_id = ".$botid." AND configkey = '".$class_db->getRealEscapeString($configkey)."'");
			}
		}
		else
		{
			$class_db->db_query("INSERT INTO jts3servermod_instanceconfig (`instance_id`, `configkey`, `configvalue`) VALUES (".$botid.", '".$class_db->getRealEscapeString($configkey)."', '".$class_db->getRealEscapeString($configvalue)."')");
		}

		return true;
	}
	else
	{
		return false;
	}
}

$userid = -1;
if (isset($_SESSION['userid']) && is_numeric($_SESSION['userid']))
	$userid = $_SESSION['userid'];

require("class/dbconnect.php");
$class_db = new dbconnect();

require("class/BotTelnet.php");
$botTelnet = new BotTelnet($class_db);

$configValues = array();
$resultSettings = $class_db->db_query("SELECT configkey, configvalue FROM jts3servermodwebui_settings WHERE configkey IN ('bootui_version', 'bootui_hash')");
while($row = mysqli_fetch_row($resultSettings)) {
	$configValues[$row[0]] = $row[1];
}

if (isset($_POST['mode']) && $_POST['mode'] == "botstatusall")
{
	$botStatusArray = array();
	if (isset($_SESSION['adminlevel']) && $_SESSION['adminlevel'] > 0)
	{
		$botStatusArray = $botTelnet->getBotStatusAll();
	}
	
	echo json_encode($botStatusArray);
}
else if (isset($_POST['mode']) && $_POST['mode'] == "botstatus")
{
	if (!isset($_POST['botlistuserid']) || !is_numeric($_POST['botlistuserid']))
	{
		die("ERR 3");
	}
	
	$currentUserIDBotList = $_SESSION['userid'];
	$botStatusArray = $botTelnet->getBotStatusAll();
	$botStatusArrayLimited = array();
	
	if (isset($_SESSION['adminlevel']) && $_SESSION['adminlevel'] > 0)
	{
		if ($currentUserIDBotList != $_POST['botlistuserid'])
			$currentUserIDBotList = $_POST['botlistuserid'];
	}
	
	$resListBots = $class_db->db_query("SELECT jts3servermod_instances.name FROM jts3servermodwebui_usersinstances, jts3servermod_instances WHERE jts3servermodwebui_usersinstances.instance_id = jts3servermod_instances.id AND jts3servermodwebui_usersinstances.user_id = ".$currentUserIDBotList);
	while($row = mysqli_fetch_row($resListBots))
	{
		$botStatusArrayLimited[$row[0]] = $botStatusArray[$row[0]];
	}
	
	echo json_encode($botStatusArrayLimited);
}
else if (isset($_POST['mode']) && $_POST['mode'] == "botstatusheader")
{
	if (!isset($_POST['botid']) || !is_numeric($_POST['botid']))
	{
		die("ERR 2");
	}
	
	$isAllowed = $class_db->getQuery("SELECT COUNT(*) FROM jts3servermodwebui_usersinstances WHERE instance_id = ".$_POST['botid']." AND user_id = ".$_SESSION['userid']);
	if ($isAllowed[0] == 0 && (isset($_SESSION['adminlevel']) && $_SESSION['adminlevel'] < 1))
		die("ERR 4");
	
	require_once("class/Translation.php");
	$translation = new Translation($class_db, (isset($_SESSION['languageid']) && is_numeric($_SESSION['languageid']) ? $_SESSION['languageid'] : null));
	
	require("include/botheaderfunctions.php");
	
	$serverInfo = getBotInfo($class_db, $_POST['botid']);
	$botStatus = $botTelnet->getBotStatus($serverInfo[0]);
	$botStatusHTML = getBotStatusHTML($botStatus, $_POST['botid']);
	$botStatusHTML = $translation->replaceTranslationsForPage($botStatusHTML, "various");
	if (isset($botStatusHTML["botcommands"]))
		$botStatusHTML["botcommands"] = str_replace('{botID}', $_POST['botid'], $botStatusHTML["botcommands"]);
	
    $botLogStatus = getLogStatus($_POST['botid'], $class_db);
    
	echo json_encode(array_merge($botStatusHTML, $botLogStatus));
}
else if (isset($_POST['mode']) && $_POST['mode'] == "botcommand")
{
	require_once("class/Translation.php");
	$translation = new Translation($class_db, (isset($_SESSION['languageid']) && is_numeric($_SESSION['languageid']) ? $_SESSION['languageid'] : null));
	
	if ($_POST['command'] == "instancelistreload")
	{
		if (isset($_SESSION['adminlevel']) && $_SESSION['adminlevel'] > 1)
		{
			if ($botTelnet->instancelistReload())
			{
				die($translation->getTranslation("webui_botcmdinstancelistreloadmsg"));
			}
			else
			{
				die($translation->getTranslation("webui_botcmdinstancelistreloaderror"));
			}
		}
		else
		{
			die($translation->getTranslation("webui_onlyadministrator"));
		}
	}
	else if (!isset($_POST['botid']) || !is_numeric($_POST['botid']))
	{
		die("ERR 2");
	}
	
	$isAllowed = $class_db->getQuery("SELECT COUNT(*) FROM jts3servermodwebui_usersinstances WHERE instance_id = ".$_POST['botid']." AND user_id = ".$_SESSION['userid']);
	if ($isAllowed[0] == 0 && (isset($_SESSION['adminlevel']) && $_SESSION['adminlevel'] < 1))
		die("ERR 4");
	
	require("include/botheaderfunctions.php");
	$serverInfo = getBotInfo($class_db, $_POST['botid']);
	
	if(isset($_SESSION['lastTelnetCMD']) && $_SESSION['lastTelnetCMD'] > (time() - 5)) {
		$status = "{webui_botcmdspam}";
		$success = false;
	} else {
		$_SESSION['lastTelnetCMD'] = time();
		$success = false;
		
		if($_POST['command'] == "start") {
			if ($botTelnet->startBot($serverInfo[0])) {
				$class_db->db_query("UPDATE jts3servermod_instances SET `enabled` = '1' WHERE `id` =".$_POST['botid']);
				$status = "{webui_botcmdstartmsg}<br>".getBotCheckLogInfo($_POST['botid'], $translation);
				$success = true;
			} else {
				$status = "{webui_botcmdstarterror}";
				$success = false;
			}
		} elseif($_POST['command'] == "reload") {
			if ($botTelnet->reloadBot($serverInfo[0])) {
				$status = "{webui_botcmdreloadmsg}<br>".getBotCheckLogInfo($_POST['botid'], $translation);
				$success = true;
			} else {
				$status = "{webui_botcmdreloaderror}";
				$success = false;
			}
		} elseif($_POST['command'] == "reloadconfig") {
			if ($botTelnet->reloadBotConfig($serverInfo[0])) {
				$status = "{webui_botcmdreloadconfigmsg}<br>".getBotCheckLogInfo($_POST['botid'], $translation);
				$success = true;
			} else {
				$status = "{webui_botcmdreloadconfigerror}";
				$success = false;
			}
		} elseif($_POST['command'] == "stop") {
			if ($botTelnet->stopBot($serverInfo[0])) {
				$class_db->db_query("UPDATE jts3servermod_instances SET `enabled` = '0' WHERE `id` =".$_POST['botid']);
				$status = "{webui_botcmdstopmsg}";
				$success = true;
			} else {
				$status = "{webui_botcmdstoperror}";
				$success = false;
			}
		}
		
		$_SESSION['lastTelnetCMD'] = time();
	}
	
	$status = $translation->replaceTranslationsForPage($status, "botmanager");
	
	die(json_encode(['message' => $status, 'status' => $success ? 'success' : 'error']));
} elseif(isset($_POST['mode']) && $_POST['mode'] == 'users') {
	require_once("class/Translation.php");
	$translation = new Translation($class_db, (isset($_SESSION['languageid']) && is_numeric($_SESSION['languageid']) ? $_SESSION['languageid'] : null));

	if(isset($_POST['command']) && $_POST['command'] == 'qrregen') {
		require_once 'class/TFA.php';

		$tfa = new TFA();
		$secret = $tfa->createSecret();

		$class_db->db_query("UPDATE jts3servermodwebui_users SET `tfasecret` = '".$secret."' WHERE id = '".$_SESSION['userid']."'");

		$status = $translation->replaceTranslationsForPage("{bootui_twofactor_regen}", "bi_users");
		die(json_encode(['message' => $status, 'status' => 'success', 'code' => $secret, 'qrcode' => $tfa->getQRCodeImageAsDataUri($_SESSION['username'], $secret)]));
	} elseif(isset($_POST['command']) && $_POST['command'] == 'settings') {
		$errmsg = $sucmsg = '';
		$allOk = false;

		require_once("include/formularfunctions.php");
		require_once("class/PWHash.php");
		require_once 'class/TFA.php';

		$PWHash = new PWHash();
		$tfa = new TFA();

		if(isset($_POST['userssettings_generell_theme']) && isset($_POST['userssettings_generell_mail']) && isset($_POST['userssettings_current_password']) && isset($_POST['userssettings_new_password']) && isset($_POST['userssettings_repeat_new_password']) &&
			isset($_POST['userssettings_twofactor_activstat']) && isset($_POST['userssettings_twofactor_qrcode'])) {
			$allOk = true;

			if(!file_exists("assets/styles/".$_POST['userssettings_generell_theme'].".css") && !file_exists("assets/styles/".$_POST['userssettings_generell_theme'].".min.css")) {
				$errmsg .= "{bootui_theme_error}<br>";
				$allOk = false;
			}

			if(!empty($_POST['userssettings_new_password']) && !empty($_POST['userssettings_repeat_new_password'])) {
				$resInfo = $class_db->db_query("SELECT password, salt, email, name FROM jts3servermodwebui_users WHERE id=".$userid);

				if(mysqli_num_rows($resInfo) == 1) {
					$userInfo = mysqli_fetch_object($resInfo);

					if($PWHash->hashString($_POST['userssettings_current_password'], $userInfo->salt) == $userInfo->password) {
						if($_POST['userssettings_new_password'] == $_POST['userssettings_repeat_new_password']) {
							if(strlen($_POST['userssettings_new_password']) == 0 || !isPasswordValid($_POST['userssettings_new_password'])) {
								$errmsg .= "{bootui_changepw_notvalid}<br>";
								$allOk = false;
							} else {
								$pwsalt = $PWHash->createSalt();
								$class_db->db_query("UPDATE `jts3servermodwebui_users` SET `password`='".$class_db->getRealEscapeString($PWHash->hashString($_POST['userssettings_new_password'], $pwsalt))."', `salt`='".$pwsalt."' WHERE `id`=".$userid);

								$emailTranslation = $translation->getTranslationsForPage("pwchangeemail", false);

								$message = implode("", file("templates/pwchange_email.tmpl"));
								$message = $translation->replaceAllKeys($message, $emailTranslation);
								$message = str_replace('{homepageurl}', "http://".$_SERVER['HTTP_HOST'], $message);
								$message = str_replace('{username}', $userInfo->name, $message);
								$message = str_replace('{password}', $_POST['newpassword'], $message);
								$mailResult = mail($userInfo->email, $emailTranslation['email_subject'], wordwrap($message, 80), "From: ".getReplyAddress($class_db)."\r\nContent-Type: text/plain; charset=UTF-8\r\n");

								$sucmsg .= "{bootui_changepw_successful}<br>";
							}
						} else {
							$errmsg .= "{bootui_changepw_newpasswordnotmatch}<br>";
							$allOk = false;
						}
					} else {
						$errmsg .= "{bootui_changepw_passwordwrong}<br>";
						$allOk = false;
					}
				}
			}

			if(!is_numeric($_POST['userssettings_twofactor_activstat']) || $_POST['userssettings_twofactor_activstat'] < 0 || $_POST['userssettings_twofactor_activstat'] > 1) {
				$errmsg .= "{bootui_twofactor_wrong}<br>";
				$allOk = false;
			}

			if(isset($_POST['second']) && $_POST['second'] == 'tfa_check') {
				if (!$tfa->verifyCode($_POST['userssettings_twofactor_qrcode'], $_POST['userssettings_twofactor_authencode'], 2)) {
					$errmsg = "{bootui_twofactor_authencode_wrong}<br>";
					$allOk = false;
					$status = $translation->replaceTranslationsForPage($errmsg, "bi_users");
					die(json_encode(['message' => $status, 'status' => 'tfa_check']));
				} else {
					$sucmsg .= "{bootui_twofactor_activated}<br>";
				}
			}
		} else {
			$errmsg = "{bootui_userssetings_missingvalues}";
			$allOk = false;
		}

		if($allOk) {
			$class_db->db_query("UPDATE `jts3servermodwebui_users` SET `theme`='".$_POST['userssettings_generell_theme']."', `tfastatus`='".$_POST['userssettings_twofactor_activstat']."', `tfasecret`='".$_POST['userssettings_twofactor_qrcode']."', `email`='".$_POST['userssettings_generell_mail']."' WHERE id=".$userid);

			$_SESSION['theme'] = $_POST['userssettings_generell_theme'];

			$success = true;
			$errmsg = '{bootui_userssettings_saved}<br>'.$sucmsg;
		}

		$status = $translation->replaceTranslationsForPage($errmsg, "bi_users");
	}

	die(json_encode(['message' => $status, 'status' => $success ? 'success' : 'error']));
} elseif(isset($_POST['mode']) && $_POST['mode'] == 'auth') {
	require_once("class/Translation.php");
	$translation = new Translation($class_db, (isset($_SESSION['languageid']) && is_numeric($_SESSION['languageid']) ? $_SESSION['languageid'] : null));

	require_once("class/PWHash.php");
	$PWHash = new PWHash();

	$errmsg = '';
	$success = false;

	if(isset($_POST['command']) && $_POST['command'] == 'login') {
		if(isset($_POST['auth_login_name']) && isset($_POST['auth_login_password'])) {
			$notupdated = version_compare('1.1.0', $configValues['bootui_version'], '>');
			$compatibilityMode = false;

			if(!$notupdated) {
				$resInfo = $class_db->db_query("SELECT id, name, password, adminlevel, userstatus, logintrycount, logintrytime, salt, theme, tfastatus, tfasecret FROM jts3servermodwebui_users WHERE name = \"".$class_db->getRealEscapeString($_POST['auth_login_name'])."\" OR email = \"".$class_db->getRealEscapeString($_POST['auth_login_name'])."\"", true);

				if($resInfo === false) {
					$compatibilityMode = true;
					$resInfo = $class_db->db_query("SELECT id, name, password, adminlevel, userstatus, logintrycount, logintrytime, theme, tfastatus, tfasecret FROM jts3servermodwebui_users WHERE name = \"".$class_db->getRealEscapeString($_POST['auth_login_name'])."\" OR email = \"".$class_db->getRealEscapeString($_POST['auth_login_name'])."\"");
				}
			} else {
				$resInfo = $class_db->db_query("SELECT id, name, password, adminlevel, userstatus, logintrycount, logintrytime, salt FROM jts3servermodwebui_users WHERE name = \"".$class_db->getRealEscapeString($_POST['auth_login_name'])."\" OR email = \"".$class_db->getRealEscapeString($_POST['auth_login_name'])."\"", true);

				if($resInfo === false) {
					$compatibilityMode = true;
					$resInfo = $class_db->db_query("SELECT id, name, password, adminlevel, userstatus, logintrycount, logintrytime FROM jts3servermodwebui_users WHERE name = \"".$class_db->getRealEscapeString($_POST['auth_login_name'])."\" OR email = \"".$class_db->getRealEscapeString($_POST['auth_login_name'])."\"");
				}
			}

			if(mysqli_num_rows($resInfo) == 1) {
				$userInfo = mysqli_fetch_object($resInfo);

				if($userInfo->logintrycount > 5 && $userInfo->logintrytime > (time() - (60 * 60 * 24))) {
					// More than 5 tries in the last 24 hours
					$errmsg = "{bootui_login_spam}";
					$success = false;
				} elseif($userInfo->userstatus == -1) {
					$errmsg = "{bootui_login_deactivated}";
					$success = false;
				} else {
					if(!$compatibilityMode && strlen($userInfo->password) > 50 && $userInfo->password == $PWHash->hashString($_POST['auth_login_password'], $userInfo->salt)) {
						if($userInfo->tfastatus == 1) {
							$_SESSION['authid'] = $userInfo->id;
							die(json_encode(['status' => 'tfa_check']));
						} else {
							$class_db->db_query("UPDATE jts3servermodwebui_users SET `logintrycount` = '0', `lastvisit` = '" . time() . "', `resetkey` = '' WHERE id = ".$userInfo->id);

							$_SESSION['userid'] = $userInfo->id;
							$_SESSION['username'] = $userInfo->name;
							$_SESSION['adminlevel'] = $userInfo->adminlevel;
							$_SESSION['theme'] = $userInfo->theme;

							$errmsg = "{bootui_login_successful}";
							$success = true;
						}
					} elseif(strlen($userInfo->password) < 50 && $userInfo->password == md5(sha1(sha1($_POST['auth_login_password'])))) {
						if($userInfo->tfastatus == 1) {
							$_SESSION['authid'] = $userInfo->id;
							die(json_encode(['status' => 'tfa_check']));
						} else {
							if (!$compatibilityMode) {
								$pwsalt = $PWHash->createSalt();
								$class_db->db_query("UPDATE jts3servermodwebui_users SET `password` = '" . $PWHash->hashString($_POST['auth_login_password'], $pwsalt) . "', `salt` = '" . $pwsalt . "', `logintrycount` = '0', `lastvisit` = '" . time() . "', `resetkey` = '' WHERE id = " . $userInfo->id);
							}

							$_SESSION['userid'] = $userInfo->id;
							$_SESSION['username'] = $userInfo->name;
							$_SESSION['adminlevel'] = $userInfo->adminlevel;
							$_SESSION['theme'] = $userInfo->theme;

							$errmsg = "{bootui_login_successful}";
							$success = true;
						}
					} else {
						$errmsg = "{bootui_login_wrong}";
						$success = false;
						$class_db->db_query("UPDATE jts3servermodwebui_users SET logintrycount = logintrycount+1, `logintrytime` = '".time()."' WHERE id = ".$userInfo->id);
					}
				}
			} else {
				$errmsg = "{bootui_login_wrong}";
				$success = false;
			}
		} else {
			$errmsg = "{bootui_login_missing}";
			$success = false;
		}
	} elseif(isset($_POST['command']) && $_POST['command'] == 'tfa') {
		require_once 'class/TFA.php';
		$tfa = new TFA();

		if(isset($_POST['auth_login_authencode']) && isset($_SESSION['authid'])) {
			$resInfo = $class_db->db_query("SELECT name, adminlevel, theme, tfasecret FROM jts3servermodwebui_users WHERE id=".$_SESSION['authid']);

			if(mysqli_num_rows($resInfo) == 1) {
				$userInfo = mysqli_fetch_object($resInfo);

				if($tfa->verifyCode($userInfo->tfasecret, $_POST['auth_login_authencode'], 2)) {
					$class_db->db_query("UPDATE jts3servermodwebui_users SET `logintrycount` = '0', `lastvisit` = '" . time() . "', `resetkey` = '' WHERE id = ".$_SESSION['authid']);

					$_SESSION['userid'] = $_SESSION['authid'];
					$_SESSION['username'] = $userInfo->name;
					$_SESSION['adminlevel'] = $userInfo->adminlevel;
					$_SESSION['theme'] = $userInfo->theme;
					unset($_SESSION['authid']);

					$errmsg = "{bootui_login_successful}";
					$success = true;
				} else {
					$class_db->db_query("UPDATE jts3servermodwebui_users SET logintrycount = logintrycount+1, `logintrytime` = '".time()."' WHERE id = ".$_SESSION['authid']);
					unset($_SESSION['authid']);

					$errmsg = "{bootui_login_wrong_tfa}";
					$success = false;
				}
			}
		}
	} elseif(isset($_POST['command']) && $_POST['command'] == 'logout') {
		session_unset();
		$_SESSION=array();
		session_destroy();
		session_name($sessionName);
		@session_start();

		$errmsg = '{bootui_logout_successful}';
		$success = true;
	}

	$status = $translation->replaceTranslationsForPage($errmsg, "bi_messages");
	die(json_encode(['message' => $status, 'status' => $success ? 'success' : 'error']));
} elseif(isset($_POST['mode']) && $_POST['mode'] == 'botmanage') {
	require_once("class/Translation.php");
	require_once("include/botheaderfunctions.php");
	$translation = new Translation($class_db, (isset($_SESSION['languageid']) && is_numeric($_SESSION['languageid']) ? $_SESSION['languageid'] : null));

	if(!isset($_POST['botid']) || !is_numeric($_POST['botid'])) die('Err B01');
	if(!isset($_POST['command'])) die('Err B02');


	$errmsg = '';
	$success = false;
	$useBotID = -1;
	$isAllowed = false;

	if ((isset($_SESSION['adminlevel']) && $_SESSION['adminlevel'] > 0)) {
		$isAllowed = true;
	} else {
		$isValid = $class_db->getQuery("SELECT COUNT(*) FROM jts3servermodwebui_usersinstances WHERE user_id = ".$userid." AND instance_id = ".$_POST['botid']);
		if ($isValid[0] == 1) $isAllowed = true;
	}

	if ($isAllowed) {
		$isValid = $class_db->getQuery("SELECT COUNT(*) FROM jts3servermod_instances WHERE id = ".$_POST['botid']);
		if ($isValid[0] == 1) $useBotID = $_POST['botid'];
	} else {
		die("Err B04");
	}

	$serverInfo = getBotInfo($class_db, $useBotID);
	$botStatus = $botTelnet->getBotStatus($serverInfo[0]);

	if($_POST['command'] == 'activateFunction') {
		$functionPrefix = $_POST['prefix'];

		$botFunctions = $class_db->getQuery("SELECT configvalue FROM jts3servermod_instanceconfig WHERE instance_id = ".$useBotID." AND configkey = 'bot_functions'");
		$newBotFunctionsLine = $botFunctions[0];

		$newBotFunctionsDisabledLine = "";
		$functionClass = "";
		$botFunctionsDisabled = $class_db->getQuery("SELECT configvalue FROM jts3servermod_instanceconfig WHERE instance_id = ".$useBotID." AND configkey = 'bot_functions_disabled'");
		$functionList = explode(",", $botFunctionsDisabled[0]);
		foreach($functionList as $function) {
			$part = explode(":", $function);
			if (count($part) == 2) {
				if ($part[1] == $functionPrefix) {
					$functionClass = $part[0];
					if (strlen($newBotFunctionsLine) < 3)
						$newBotFunctionsLine = $part[0].":".$part[1];
					else
						$newBotFunctionsLine .= ",".$part[0].":".$part[1];
				} else {
					if (strlen($newBotFunctionsDisabledLine) < 3)
						$newBotFunctionsDisabledLine = $part[0].":".$part[1];
					else
						$newBotFunctionsDisabledLine .= ",".$part[0].":".$part[1];
				}
			}
		}

		saveValue($useBotID, $class_db, 'bot_functions', $newBotFunctionsLine);
		saveValue($useBotID, $class_db, 'bot_functions_disabled', $newBotFunctionsDisabledLine);

		$status = true;
		if ($botStatus == 1) {
			$serverInfo = getBotInfo($class_db, $useBotID);
			$status = $botTelnet->activateFunction($serverInfo[0], $functionPrefix);
		}

		$success = true;
		$extra = '<button type="button" data-bot="manage" data-command="deactivateFunction" data-botfunction="{function_prefix}" data-botid="{botID}" class="btn btn-info" data-toggle="tooltip" data-placement="bottom" title="{webui_disablefunction}: {webui_{function_class}_title} / {function_prefix}"><i class="fas fa-stop fa-fw"></i></button>';
		$errmsg = "{bootui_botmanage_activatefunction_successful}: ".$functionClass." / ".$functionPrefix.($status ? "" : "{botreload_info}");
	} elseif($_POST['command'] == 'deactivateFunction') {
		$functionPrefix = $_POST['prefix'];

		$botFunctionsDisabled = $class_db->getQuery("SELECT configvalue FROM jts3servermod_instanceconfig WHERE instance_id = ".$useBotID." AND configkey = 'bot_functions_disabled'");
		$newBotFunctionsDisabledLine = $botFunctionsDisabled[0];

		$newBotFunctionsLine = "";
		$functionClass = "";
		$botFunctions = $class_db->getQuery("SELECT configvalue FROM jts3servermod_instanceconfig WHERE instance_id = ".$useBotID." AND configkey = 'bot_functions'");
		$functionList = explode(",", $botFunctions[0]);
		foreach($functionList as $function) {
			$part = explode(":", $function);
			if (count($part) == 2) {
				if ($part[1] == $functionPrefix) {
					$functionClass = $part[0];
					if (strlen($newBotFunctionsDisabledLine) < 3)
						$newBotFunctionsDisabledLine = $part[0].":".$part[1];
					else
						$newBotFunctionsDisabledLine .= ",".$part[0].":".$part[1];
				} else {
					if (strlen($newBotFunctionsLine) < 3)
						$newBotFunctionsLine = $part[0].":".$part[1];
					else
						$newBotFunctionsLine .= ",".$part[0].":".$part[1];
				}
			}
		}

		saveValue($useBotID, $class_db, 'bot_functions', $newBotFunctionsLine);
		saveValue($useBotID, $class_db, 'bot_functions_disabled', $newBotFunctionsDisabledLine);

		$status = true;
		if ($botStatus == 1) {
			$serverInfo = getBotInfo($class_db, $useBotID);
			$status = $botTelnet->disableFunction($serverInfo[0], $functionPrefix);
		}

		$success = true;
		$extra = ['data-command="activateFunction"', '<i class="fas fa-play fa-fw"></i>'];
		$errmsg = "{bootui_botmanage_disablefunction_successful}: ".$functionClass." / ".$functionPrefix.($status ? "" : "{botreload_info}");
	} elseif($_POST['command'] == 'removeFunction') {
		$functionPrefix = $_POST['prefix'];
		$functionClass = $_POST['class'];

		$result = $class_db->db_query("DELETE FROM jts3servermod_instanceconfig WHERE instance_id = ".$useBotID." AND configkey LIKE '".$class_db->getRealEscapeString($functionPrefix)."_%'");

		$additionalIncludePath = "include/functions/".strtolower($functionClass).".php";
		if (file_exists($additionalIncludePath)) {
			include_once($additionalIncludePath);
			removeSpecialFunctionConfig($useBotID, $class_db, $functionPrefix);
		}

		$found = false;
		$botFunctionsDisabled = $class_db->getQuery("SELECT configvalue FROM jts3servermod_instanceconfig WHERE instance_id = ".$useBotID." AND configkey = 'bot_functions_disabled'");
		$newBotFunctionsDisabledLine = "";
		$functionListDisabled = explode(",", $botFunctionsDisabled[0]);
		foreach($functionListDisabled as $function) {
			$part = explode(":", $function);
			if (count($part) == 2) {
				if ($part[1] == $functionPrefix) {
					$found = true;
				} else {
					if (strlen($newBotFunctionsDisabledLine) < 3) {
						$newBotFunctionsDisabledLine = $part[0].":".$part[1];
					} else {
						$newBotFunctionsDisabledLine .= ",".$part[0].":".$part[1];
					}
				}
			}
		}

		if ($found) {
			saveValue($useBotID, $class_db, 'bot_functions_disabled', $newBotFunctionsDisabledLine);
			$status = $translation->getTranslation("bootui_botmanage_removefunction_successful").": ".$functionClass." / ".$functionPrefix;
			die(json_encode(['message' => $status, 'status' => 'success']));
		}

		$newBotFunctionsLine = "";
		$botFunctions = $class_db->getQuery("SELECT configvalue FROM jts3servermod_instanceconfig WHERE instance_id = ".$useBotID." AND configkey = 'bot_functions'");
		$functionList = explode(",", $botFunctions[0]);
		foreach($functionList as $function) {
			$part = explode(":", $function);
			if (count($part) == 2) {
				if ($part[1] == $functionPrefix) {
					// do nothing
				} else {
					if (strlen($newBotFunctionsLine) < 3) {
						$newBotFunctionsLine = $part[0].":".$part[1];
					} else {
						$newBotFunctionsLine .= ",".$part[0].":".$part[1];
					}
				}
			}
		}

		saveValue($useBotID, $class_db, 'bot_functions', $newBotFunctionsLine);

		$status = $translation->getTranslation("bootui_botmanage_removefunction_successful").": ".$functionClass." / ".$functionPrefix."{botreload_info}";
		$status = str_replace('{botreload_info}', getBotReloadInfo($useBotID, $botTelnet, $serverInfo, $status), $status);
		die(json_encode(['message' => $status, 'status' => 'success']));
	} elseif($_POST['command'] == 'renameFunction') {
		$functionPrefix_new = $_POST['prefixnew'];
		$functionPrefix_old = $_POST['prefixold'];
		$functionClass = $_POST['class'];

		$uniqueName = true;
		$botFunctions = $class_db->getQuery("SELECT configvalue FROM jts3servermod_instanceconfig WHERE instance_id = ".$useBotID." AND configkey = 'bot_functions'");
		$functionList = explode(",", $botFunctions[0]);
		foreach($functionList as $function) {
			$part = explode(":", $function);
			if (count($part) == 2) {
				if ($part[1] == $functionPrefix_new) {
					$uniqueName = false;
				}
			}
		}

		if (!$uniqueName) {
			die(json_encode(['message' => $translation->getTranslation("bootui_botmanage_addfunction_nouniquename"), 'status' => 'nounique']));
		}

		$botFunctionsDisabled = $class_db->getQuery("SELECT configvalue FROM jts3servermod_instanceconfig WHERE instance_id = ".$useBotID." AND configkey = 'bot_functions_disabled'");
		$functionList = explode(",", $botFunctionsDisabled[0]);
		foreach($functionList as $function) {
			$part = explode(":", $function);
			if (count($part) == 2) {
				if ($part[1] == $functionPrefix_new) {
					$uniqueName = false;
				}
			}
		}

		if (!$uniqueName) {
			die(json_encode(['message' => $translation->getTranslation("bootui_botmanage_addfunction_nouniquename"), 'status' => 'nounique']));
		}

		$newBotFunctionsLine = renameFunctionLine($botFunctions[0], $functionPrefix_old, $functionPrefix_new);
		if ($newBotFunctionsLine === false) {
			$newBotFunctionsLine = renameFunctionLine($botFunctionsDisabled[0], $functionPrefix_old, $functionPrefix_new);

			if ($newBotFunctionsLine !== false)
				saveValue($useBotID, $class_db, 'bot_functions_disabled', $newBotFunctionsLine);
		} else {
			saveValue($useBotID, $class_db, 'bot_functions', $newBotFunctionsLine);
		}

		if ($newBotFunctionsLine === false) {
			die(json_encode(['message' => $translation->getTranslation("bootui_botmanage_renamefunction_notfound").": ".$functionPrefix_old, 'status' => 'error']));
		} else {
			$class_db->db_query("UPDATE jts3servermod_log SET functionname = '".$class_db->getRealEscapeString($functionPrefix_new)."' WHERE instance_id = ".$useBotID." AND functionname = '".$class_db->getRealEscapeString($functionPrefix_old)."'");

			$resList = $class_db->db_query("SELECT configkey FROM jts3servermodwebui_functionpage, jts3servermodwebui_botfunction WHERE botfunction_id = id AND classname = \"".$class_db->getRealEscapeString($functionClass)."\"");
			while($row = mysqli_fetch_row($resList)) {
				$class_db->db_query("UPDATE jts3servermod_instanceconfig SET configkey = '".$class_db->getRealEscapeString($functionPrefix_new.$row[0])."' WHERE instance_id = ".$useBotID." AND configkey = '".$class_db->getRealEscapeString($functionPrefix_old.$row[0])."'");
			}

			$additionalIncludePath = "include/functions/".strtolower($_POST['function_class']).".php";
			if (file_exists($additionalIncludePath)) {
				include_once($additionalIncludePath);
				renameSpecialFunctionConfig($useBotID, $class_db, $functionPrefix_old, $functionPrefix_new);
			}

			$status = $translation->getTranslation("bootui_botmanage_renamefunction_successful").": ".$functionPrefix_old." -&gt; ".$functionPrefix_new."{botreload_info}";
			$status = str_replace('{botreload_info}', getBotReloadInfo($useBotID, $botTelnet, $serverInfo, $status), $status);
			die(json_encode(['message' => $status, 'status' => 'success']));
		}
	}

	$message = $translation->replaceTranslationsForPage($errmsg, "bi_messages");
	$extra = $translation->replaceTranslationsForPage($extra, "bi_messages");
	if(isset($extra))
		die(json_encode(['message' => $message, 'status' => $success ? 'success' : 'error', 'extra' => $extra]));
	else
		die(json_encode(['message' => $message, 'status' => $success ? 'success' : 'error']));
} else {
	die(json_encode(['message' => 'ERR 9', 'status' => 'error']));
}

function renameFunctionLine($botFunctionsLine, $functionPrefix_old, $functionPrefix_new)
{
	$newBotFunctionsLine = false;

	$pos = strpos($botFunctionsLine, ":".$functionPrefix_old.",");
	if ($pos === FALSE)
	{
		if (substr($botFunctionsLine, (strlen(":".$functionPrefix_old) * (-1))) == ":".$functionPrefix_old)
		{
			$newBotFunctionsLine = substr($botFunctionsLine, 0, (strlen($functionPrefix_old) * (-1)));
			$newBotFunctionsLine .= $functionPrefix_new;
		}
	}
	else
	{
		$newBotFunctionsLine = str_replace(":".$functionPrefix_old.",", ":".$functionPrefix_new.",", $botFunctionsLine);
	}

	return $newBotFunctionsLine;
}

function getBotReloadInfo($botID, $botTelnet, $serverInfo, $status, $botStatus = null)
{
	$pos = strpos($status, '{botreload_info}');

	if ($pos === FALSE)
	{
		return "";
	}
	else
	{
		if ($botStatus == null) $botStatus = $botTelnet->getBotStatus($serverInfo[0]);
		return ($botStatus == 1 ? "<br><a href=\"javascript:void(0);\" class=\"nounderline\" onclick=\"requestBotCommand(".$botID.", 'reload');\">{webui_botsettingssaved_reloadbot} <img src=\"assets/images/arrow_refresh_small.png\" border=\"0\" alt=\"\" class=\"middle\"></a>" : "");
	}
}
?>